> For the complete documentation index, see [llms.txt](https://docs.finpay.id/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.finpay.id/api-reference/finpay-pg/core-api/credit-card/advance-payment/direct-integration/3ds-transaction/3ds-initiation.md).

# 3DS Initiation

**Card Holder Data entry in Merchant site**

| Environment | Method | URL                                                          |
| ----------- | ------ | ------------------------------------------------------------ |
| Development | POST   | <https://devo.finnet.co.id/pg/payment/card/threeds/initiate> |
| Production  | POST   | <https://live.finnet.co.id/pg/payment/card/threeds/initiate> |

### Data Request <a href="#data-request" id="data-request"></a>

| No | Name        | Type                                                                 | Mandatory | Min Length | Max Length | Description            |
| -- | ----------- | -------------------------------------------------------------------- | --------- | ---------- | ---------- | ---------------------- |
| 1  | customer    | [Object](/api-reference/appendix/json-object/customer-object.md)     | M         | 1          | 8          | Detail of Customer     |
| 2  | order       | [Object](/api-reference/appendix/json-object/order-object.md)        | M         | 1          | 12         | Detail of Order        |
| 3  | url         | [Object](/api-reference/appendix/json-object/url-object.md)          | M         | 1          | 4          | Detail of Url          |
| 4  | card        | [Object](/api-reference/appendix/json-object/card-object.md)         | M         | 1          | 7          | Detail of Card         |
| 5  | billing     | [Object](/api-reference/appendix/json-object/billing-object.md)      | O         | 1          | 1          | Detail of Billing      |
| 6  | shipping    | [Object](/api-reference/appendix/json-object/shipping-object.md)     | O         | 1          | 4          | Detail of Shipping     |
| 7  | transaction | [Object](/api-reference/appendix/json-object/transaction-object.md)  | O         | 1          | 3          | Detail of Transaction  |
| 8  | paymentPlan | [Object](/api-reference/appendix/json-object/payment-plan-object.md) | O         | 1          | 1          | Detail of Payment Plan |
| 9  | device      | [Object](/api-reference/appendix/json-object/device-object.md)       | M         | 1          | 7          | Detail of Device       |

#### Sample Request <a href="#sample-request" id="sample-request"></a>

```
{
  "billing": {
    "address": {
      "city": "Jakarta Selatan",
      "company": "Finnet Indonesia",
      "country": "IDN",
      "postcodeZip": "12740",
      "stateProvince": "DKI Jakarta",
      "stateProvinceCode": "31",
      "street": "Jalan Gatot Subroto",
      "street2": "Jalan Gatot Subroto"
    }
  },
  "shipping": {
    "method": "SAME_DAY",
    "origin": {
      "postcodeZip": "12740"
    },
    "contact": {
      "email": "hajar.finnet@gmail.com",
      "firstName": "Hajar",
      "lastName": "Ismail",
      "mobilePhone": "+6281286288844",
      "phone": "+62211500770"
    },
    "address": {
      "city": "Jakarta Selatan",
      "company": "Finnet Indonesia",
      "country": "IDN",
      "postcodeZip": "12740",
      "stateProvince": "DKI Jakarta",
      "stateProvinceCode": "31",
      "street": "Jalan Gatot Subroto",
      "street2": "Jalan Gatot Subroto",
      "source": "Jakarta",
      "sameAsBilling": "SAME"
    }
  },
  "customer": {
    "id": "hajar@yahoo.com",
    "email": "hajar.finnet@gmail.com",
    "firstName": "Hajar",
    "lastName": "Ismail",
    "mobilePhone": "+6281286288844",
    "phone": "+6281286288844",
    "taxRegistrationId": "123456",
    "account": {
      "id": "1234"
    }
  },
  "order": {
    "id": "{{orderId}}",
    "amount": "1000",
    "lifetime": "1000",

    "description": "Testing",
    "itemAmount": "900",
    "localTaxRegistrationId": "1234",
    "merchantCategoryCode": "1234",
    "surchargeAmount": "100",
    "item": [
      {
        "brand": "brand1",
        "category": "category",
        "description": "description",
        "industryCategory": "industryCategory",
        "name": "name",
        "quantity": "1",
        "sku": "sku",
        "unitDiscountAmount": "100",
        "unitOfMeasure": "1",
        "unitPrice": "100",
        "unitTaxAmount": "100"
      },
      {
        "brand": "brand2",
        "category": "category",
        "description": "description",
        "industryCategory": "industryCategory",
        "name": "name",
        "quantity": "1",
        "sku": "sku",
        "unitDiscountAmount": "100",
        "unitOfMeasure": "1",
        "unitPrice": "100",
        "unitTaxAmount": "100"
      }
    ],
    "subMerchant": {
      "disputeContactPhone": "+62211500770",
      "email": "hajar.finnet@gmail.com",
      "registeredName": "Finnet",
      "tradingName": "Finpay",
      "address": {
        "city": "Jakarta Selatan",
        "company": "Finnet Indonesia",
        "country": "IDN",
        "postcodeZip": "12740",
        "stateProvince": "DKI Jakarta",
        "stateProvinceCode": "31",
        "street": "Jalan Gatot Subroto",
        "street2": "Jalan Gatot Subroto"
      }
    }
  },
  "recurring": {
    "productCode": "001001",
    "type": "PURCHASE",
    "id": "abcd",
    "amount": "1000",
    "interval": "1",
    "intervalUnit": "monthly",
    "maxInterval": "2",
    "startDate": "20220101",
    "endDate": "20220101",
    "retry": {
      "interval": "1",
      "intervalUnit": "minutes",
      "maxInterval": "1"
    }
  },
  "url": {
    "backUrl": "https://sandbox.finpay.co.id/simdev/finpay/result/resultfailed.php",
    "successUrl": "https://sandbox.finpay.co.id/simdev/finpay/result/resultsuccess.php",
    "failUrl": "https://sandbox.finpay.co.id/simdev/finpay/result/resultfailed.php",
    "callbackUrl": "https://sandbox.finpay.co.id/simdev/finpay/result/tangkapCurl.php"
  },
  "card": {
    "number": "5123450000000008"
  },
  "device": {
    "ani": "1",
    "aniCallType": "ID",
    "browser": "MOZILLA",
    "fingerprint": "121311",
    "hostname": "telkom",
    "ipAddress": "202.1.201.1",
    "mobilePhoneModel": "ANDROID"
  },
  "paymentPlan": {
    "term": "12"
  },
  "transaction": {
    "mode": "PURCHASE"
  }
}
```

### Data Response <a href="#data-response" id="data-response"></a>

#### Sample Response <a href="#sample-response" id="sample-response"></a>

```
{
  "responseCode": "2000000",
  "responseMessage": "Success",
  "redirectHtml": "<div id=\"initiate3dsSimpleRedirect\" xmlns=\"http://www.w3.org/1999/html\"> <iframe id=\"methodFrame\" name=\"methodFrame\" height=\"100\" width=\"200\" > </iframe> <form id =\"initiate3dsSimpleRedirectForm\" method=\"POST\" action=\"https://ap.gateway.mastercard.com/acs/mastercard/v2/method\" target=\"methodFrame\"> <input type=\"hidden\" name=\"threeDSMethodData\" value=\"eyJ0aHJlZURTTWV0aG9kTm90aWZpY2F0aW9uVVJMIjoiaHR0cHM6Ly9hcC5nYXRld2F5Lm1hc3RlcmNhcmQuY29tL2NhbGxiYWNrSW50ZXJmYWNlL2dhdGV3YXkvYWQ1YjU2ZWVhM2RjMDg1ZTk4ZDIxZGU1MThlYmE2NDk1YzlmMmZlYWE4NjllNjk1MjU5MzRlY2MzN2RkODkwNCIsInRocmVlRFNTZXJ2ZXJUcmFuc0lEIjoiMDA0MjJiY2YtYzE2Mi00MjhjLWJjOTctZWNlOTQ3YzRlNGQ4In0=\" /> </form> <script id=\"initiate-authentication-script\"> var e=document.getElementById(\"initiate3dsSimpleRedirectForm\"); if (e) { e.submit(); if (e.parentNode !== null) { e.parentNode.removeChild(e); } } </script> </div>",
  "sessionId": "1eb0d9c4ea19d8db87225807f8e5bf8dcd81c3010fadd65147d5ce4f550299b5",
  "processingTime": 1.5691940784454346
}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.finpay.id/api-reference/finpay-pg/core-api/credit-card/advance-payment/direct-integration/3ds-transaction/3ds-initiation.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
